-------------------------------------------------------------------------------
--! @file       f1.vhd
--! @author     Farnoud Farahmand
--! @brief      f1 unit for CLOC 
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity f1 is
generic (n : integer :=128);
    Port ( inf1 : in  STD_LOGIC_vector (n-1 downto 0);
           opf1 : out  STD_LOGIC_vector (n-1 downto 0));
end f1;

architecture dataflow of f1 is

signal s1 : std_logic_vector (31 downto 0);
signal s2 : std_logic_vector (31 downto 0);
signal s3 : std_logic_vector (31 downto 0);
signal s4 : std_logic_vector (31 downto 0);
signal s5 : std_logic_vector (127 downto 0);

begin


s1 <= inf1 (127 downto 96);
s2 <= inf1 (95 downto 64);
s3 <= inf1 (63 downto 32);
s4 <= inf1 (31 downto 0);


s5 <= (s1 xor s3) & (s2 xor s4) & (s1 xor s2 xor s3) & (s2 xor s3 xor s4);

			  
opf1 <= s5;


end dataflow;



