-------------------------------------------------------------------------------
--! @file       f2.vhd
--! @author     Farnoud Farahmand
--! @brief      f2 unit for CLOC 
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity f2 is
generic (N : integer :=128);
    Port ( inf2 : in  STD_LOGIC_vector (N-1 downto 0);
           opf2 : out  STD_LOGIC_vector (N-1 downto 0));
end f2;

architecture dataflow of f2 is

signal s1 : std_logic_vector (31 downto 0);
signal s2 : std_logic_vector (31 downto 0);
signal s3 : std_logic_vector (31 downto 0);
signal s4 : std_logic_vector (31 downto 0);
signal s5 : std_logic_vector (127 downto 0);

begin


s1 <= inf2 (127 downto 96);
s2 <= inf2 (95 downto 64);
s3 <= inf2 (63 downto 32);
s4 <= inf2 (31 downto 0);


s5 <= s2 & s3 & s4 & (s1 xor s2);

			  
opf2 <= s5;



end dataflow;

