-------------------------------------------------------------------------------
--! @file       g1.vhd
--! @author     Farnoud Farahmand
--! @brief      g1 unit for CLOC 
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity g1 is
generic (N : integer :=128);
    Port ( inpg1 : in  STD_LOGIC_vector (N-1 downto 0);
           opg1 : out  STD_LOGIC_vector (N-1 downto 0));
end g1;

architecture dataflow of g1 is

signal s1 : std_logic_vector (31 downto 0);
signal s2 : std_logic_vector (31 downto 0);
signal s3 : std_logic_vector (31 downto 0);
signal s4 : std_logic_vector (31 downto 0);
signal s5 : std_logic_vector (127 downto 0);

begin


s1 <= inpg1 (127 downto 96);
s2 <= inpg1 (95 downto 64);
s3 <= inpg1 (63 downto 32);
s4 <= inpg1 (31 downto 0);


s5 <= s3 & s4 & (s1 xor s2) & (s2 xor s3);


			  
opg1 <= s5;



end dataflow;

