-------------------------------------------------------------------------------
--! @file       h.vhd
--! @author     Farnoud Farahmand
--! @brief      h unit for CLOC 
-------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity h is
generic (N : integer:= 128);
port ( hin : in std_logic_vector (N-1 downto 0);
       hop : out std_logic_vector (N-1 downto 0));
end h;

architecture dataflow of h is

signal s1 : std_logic_vector (31 downto 0);
signal s2 : std_logic_vector (31 downto 0);
signal s3 : std_logic_vector (31 downto 0);
signal s4 : std_logic_vector (31 downto 0);
signal s5 : std_logic_vector (127 downto 0);


begin


s1 <= hin (127 downto 96);
s2 <= hin (95 downto 64);
s3 <= hin (63 downto 32);
s4 <= hin (31 downto 0);



s5 <= (s1 xor s2) & (s2 xor s3) & (s3 xor s4) & (s1 xor s2 xor s4);


			  
hop <= s5;

end dataflow;

